diff --git a/grade/edit/tree/lib.php b/grade/edit/tree/lib.php
index e0f94b7..8e6fd4a 100755
--- a/grade/edit/tree/lib.php
+++ b/grade/edit/tree/lib.php
@@ -84,7 +84,7 @@ class grade_edit_tree {
         $this->table = new html_table();
         $this->table->id = "grade_edit_tree_table";
         $this->table->cellpadding = 5;
-        $this->table->add_classes(array('generaltable', $mode));
+        $this->table->attributes['class'] = 'generaltable ' . $mode;
         $this->table->style = $widthstyle;
 
         foreach ($this->columns as $column) {
@@ -161,7 +161,7 @@ class grade_edit_tree {
             // do not diplay children
             $cell = new html_table_cell();
             $cell->colspan = 12;
-            $cell->add_classes(array($element['type'], 'moving'));
+            $cell->attributes['class'] = $element['type'] . ' moving';
             $cell->text = $object->name.' ('.get_string('move').')';
             return array(new html_table_row(array($cell)));
         }
@@ -278,16 +278,16 @@ class grade_edit_tree {
             }
 
             $row = new html_table_row();
-            $row->add_classes(array($courseclass, 'category', $dimmed));
+            $row->attributes['class'] = $courseclass . ' category ' . $dimmed;
             foreach ($rowclasses as $class) {
-                $row->add_class($class);
+                $row->attributes['class'] .= ' ' . $class;
             }
 
             $headercell = new html_table_cell();
             $headercell->header = true;
             $headercell->scope = 'row';
-            $headercell->title = $object->stripped_name;
-            $headercell->add_classes(array('cell', 'rowspan', $levelclass));
+            $headercell->attributes['title'] = $object->stripped_name;
+            $headercell->attributes['class'] = 'cell rowspan ' . $levelclass;
             $headercell->rowspan = $row_count+1+$row_count_offset;
             $row->cells[] = $headercell;
 
@@ -304,7 +304,7 @@ class grade_edit_tree {
             // Print a coloured row to show the end of the category accross the table
             $endcell = new html_table_cell();
             $endcell->colspan = (19 - $level);
-            $endcell->add_classes(array('colspan', $levelclass));
+            $endcell->attributes['class'] = 'colspan ' . $levelclass;
 
             $returnrows[] = new html_table_row(array($endcell));;
 
@@ -321,9 +321,9 @@ class grade_edit_tree {
 
             $dimmed = ($item->is_hidden()) ? "dimmed_text" : "";
             $gradeitemrow = new html_table_row();
-            $gradeitemrow->add_classes(array($categoryitemclass, 'item', $dimmed));
+            $gradeitemrow->attributes['class'] = $categoryitemclass . ' item ' . $dimmed;
             foreach ($rowclasses as $class) {
-                $gradeitemrow->add_class($class);
+                $gradeitemrow->attributes['class'] .= ' ' . $class;
             }
 
             foreach ($this->columns as $column) {
@@ -518,13 +518,13 @@ abstract class grade_edit_tree_column {
         $this->headercell = new html_table_cell();
         $this->headercell->header = true;
         $this->headercell->style = 'whitespace: normal;';
-        $this->headercell->add_class('header');
+        $this->headercell->attributes['class'] = 'header';
 
         $this->categorycell = new html_table_cell();
-        $this->categorycell->add_class('cell');
+        $this->categorycell->attributes['class']  = 'cell';
 
         $this->itemcell = new html_table_cell();
-        $this->itemcell->add_class('cell');
+        $this->itemcell->attributes['class'] = 'cell';
     }
 }
 
@@ -573,7 +573,7 @@ class grade_edit_tree_column_name extends grade_edit_tree_column {
 
     public function get_header_cell() {
         $headercell = clone($this->headercell);
-        $headercell->add_class('name');
+        $headercell->attributes['class'] .= ' name';
         $headercell->colspan = $this->deepest_level + 1;
         $headercell->text = get_string('name');
         return $headercell;
@@ -585,7 +585,7 @@ class grade_edit_tree_column_name extends grade_edit_tree_column {
             throw new Exception('Array key (name or level) missing from 3rd param of grade_edit_tree_column_name::get_category_cell($category, $levelclass, $params)');
         }
         $categorycell = clone($this->categorycell);
-        $categorycell->add_classes(array('name', $levelclass));
+        $categorycell->attributes['class'] .= ' name ' . $levelclass;
         $categorycell->colspan = ($this->deepest_level +1) - $params['level'];
         $categorycell->text = $OUTPUT->heading($params['name'], 4);
         return $categorycell;
@@ -601,7 +601,7 @@ class grade_edit_tree_column_name extends grade_edit_tree_column {
         $name = $params['name'];
 
         $itemcell = clone($this->itemcell);
-        $itemcell->add_class('name');
+        $itemcell->attributes['class'] .= ' name';
         $itemcell->colspan = ($this->deepest_level + 1) - $params['level'];
         $itemcell->text = $name;
         return $itemcell;
@@ -659,7 +659,7 @@ class grade_edit_tree_column_aggregation extends grade_edit_tree_column_category
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = $aggregation;
         return $categorycell;
 
@@ -684,7 +684,7 @@ class grade_edit_tree_column_extracredit extends grade_edit_tree_column {
     public function get_category_cell($category, $levelclass, $params) {
         $item = $category->get_grade_item();
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = grade_edit_tree::get_weight_input($item, 'extra');
         return $categorycell;
     }
@@ -727,7 +727,7 @@ class grade_edit_tree_column_weight extends grade_edit_tree_column {
 
         $item = $category->get_grade_item();
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class']  .= ' ' . $levelclass;
         $categorycell->text = grade_edit_tree::get_weight_input($item, 'weight');
         return $categorycell;
     }
@@ -766,7 +766,7 @@ class grade_edit_tree_column_range extends grade_edit_tree_column {
 
     public function get_category_cell($category, $levelclass, $params) {
         $categorycell = clone($this->categorycell);
-        $categorycell->add_classes(array('range', $levelclass));
+        $categorycell->attributes['class'] .= ' range ' . $levelclass;
         $categorycell->text = ' - ';
         return $categorycell;
     }
@@ -828,7 +828,7 @@ class grade_edit_tree_column_aggregateonlygraded extends grade_edit_tree_column_
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = $hidden.$aggregateonlygraded;
         return $categorycell;
     }
@@ -865,7 +865,7 @@ class grade_edit_tree_column_aggregatesubcats extends grade_edit_tree_column_cat
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = $hidden.$aggregatesubcats;
         return $categorycell;
 
@@ -903,7 +903,7 @@ class grade_edit_tree_column_aggregateoutcomes extends grade_edit_tree_column_ca
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = $hidden.$aggregateoutcomes;
         return $categorycell;
     }
@@ -945,7 +945,7 @@ class grade_edit_tree_column_droplow extends grade_edit_tree_column_category {
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class']  .= ' ' . $levelclass;
         $categorycell->text = $droplow;
         return $categorycell;
     }
@@ -978,7 +978,7 @@ class grade_edit_tree_column_keephigh extends grade_edit_tree_column_category {
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = $keephigh;
         return $categorycell;
     }
@@ -1005,7 +1005,7 @@ class grade_edit_tree_column_multfactor extends grade_edit_tree_column {
 
     public function get_category_cell($category, $levelclass, $params) {
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = ' - ';
         return $categorycell;
     }
@@ -1046,7 +1046,7 @@ class grade_edit_tree_column_plusfactor extends grade_edit_tree_column {
 
     public function get_category_cell($category, $levelclass, $params) {
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = ' - ';
         return $categorycell;
 
@@ -1086,7 +1086,7 @@ class grade_edit_tree_column_actions extends grade_edit_tree_column {
 
     public function get_header_cell() {
         $headercell = clone($this->headercell);
-        $headercell->add_class('actions');
+        $headercell->attributes['class'] .= ' actions';
         $headercell->text = get_string('actions');
         return $headercell;
     }
@@ -1098,7 +1098,7 @@ class grade_edit_tree_column_actions extends grade_edit_tree_column {
         }
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_class($levelclass);
+        $categorycell->attributes['class'] .= ' ' . $levelclass;
         $categorycell->text = $params['actions'];
         return $categorycell;
     }
@@ -1108,7 +1108,7 @@ class grade_edit_tree_column_actions extends grade_edit_tree_column {
             throw new Exception('Array key (actions) missing from 2nd param of grade_edit_tree_column_actions::get_item_cell($item, $params)');
         }
         $itemcell = clone($this->itemcell);
-        $itemcell->add_class('actions');
+        $itemcell->attributes['class'] .= ' actions';
         $itemcell->text = $params['actions'];
         return $itemcell;
     }
@@ -1122,7 +1122,7 @@ class grade_edit_tree_column_select extends grade_edit_tree_column {
 
     public function get_header_cell() {
         $headercell = clone($this->headercell);
-        $headercell->add_class('selection');
+        $headercell->attributes['class'] .= ' selection';
         $headercell->text = get_string('select');
         return $headercell;
     }
@@ -1136,7 +1136,7 @@ class grade_edit_tree_column_select extends grade_edit_tree_column {
         $selectnone = new action_link(new moodle_url('#'), get_string('none'), new component_action('click', 'togglecheckboxes', array('eid' => $params['eid'], 'check' => false)));
 
         $categorycell = clone($this->categorycell);
-        $categorycell->add_classes(array('last', $levelclass));
+        $categorycell->attributes['class'] .= ' last ' . $levelclass;
         $categorycell->style .= 'text-align: center;';
         $categorycell->text = $OUTPUT->render($selectall) . '<br />' . $OUTPUT->render($selectnone);
         return $categorycell;
diff --git a/grade/export/keymanager.php b/grade/export/keymanager.php
index c678e9b..b6d7314 100644
--- a/grade/export/keymanager.php
+++ b/grade/export/keymanager.php
@@ -74,7 +74,7 @@ $table->size  = array('50%', '30%', '10%', '10%');
 $table->align = array('left', 'left', 'left', 'center');
 $table->width = '90%';
 $table->data  = $data;
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->container_start('buttons mdl-align');
 echo $OUTPUT->single_button(new moodle_url('key.php', array('courseid'=>$course->id)), get_string('newuserkey', 'userkey'));
diff --git a/grade/import/keymanager.php b/grade/import/keymanager.php
index 07fb12c..7d469f6 100644
--- a/grade/import/keymanager.php
+++ b/grade/import/keymanager.php
@@ -71,7 +71,7 @@ $table->size  = array('50%', '30%', '10%', '10%');
 $table->align = array('left', 'left', 'left', 'center');
 $table->width = '90%';
 $table->data  = $data;
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->container_start('buttons mdl-align');
 echo $OUTPUT->single_button(new moodle_url('key.php', array('courseid'=>$course->id)), get_string('newuserkey', 'userkey'));
diff --git a/grade/report/grader/lib.php b/grade/report/grader/lib.php
index a7e5378..dfedc46 100644
--- a/grade/report/grader/lib.php
+++ b/grade/report/grader/lib.php
@@ -545,7 +545,7 @@ class grade_report_grader extends grade_report {
 
         for ($i = 0; $i < $levels; $i++) {
             $fillercell = new html_table_cell();
-            $fillercell->add_classes(array('fixedcolumn', 'cell', 'topleft'));
+            $fillercell->attributes['class'] = 'fixedcolumn cell topleft';
             $fillercell->text = ' ';
             $fillercell->colspan = $colspan;
             $row = new html_table_row(array($fillercell));
@@ -553,10 +553,10 @@ class grade_report_grader extends grade_report {
         }
 
         $headerrow = new html_table_row();
-        $headerrow->add_class('heading');
+        $headerrow->attributes['class'] = 'heading';
 
         $studentheader = new html_table_cell();
-        $studentheader->add_classes(array('header'));
+        $studentheader->attributes['class'] = 'header';
         $studentheader->scope = 'col';
         $studentheader->header = true;
         $studentheader->id = 'studentheader';
@@ -572,7 +572,7 @@ class grade_report_grader extends grade_report {
             $sortidnumberlink = html_writer::link(new moodle_url($this->baseurl, array('sortitemid'=>'idnumber')), get_string('idnumber'));
 
             $idnumberheader = new html_table_cell();
-            $idnumberheader->add_classes(array('header', 'useridnumber'));
+            $idnumberheader->attributes['class'] = 'header useridnumber';
             $idnumberheader->scope = 'col';
             $idnumberheader->header = true;
             $idnumberheader->text = $arrows['idnumber'];
@@ -589,10 +589,10 @@ class grade_report_grader extends grade_report {
         foreach ($this->users as $userid => $user) {
             $userrow = new html_table_row();
             $userrow->id = 'fixed_user_'.$userid;
-            $userrow->add_classes(array('r'.$this->rowcount++, $rowclasses[$this->rowcount % 2]));
+            $userrow->attributes['class'] = 'r'.$this->rowcount++ . $rowclasses[$this->rowcount % 2];
 
             $usercell = new html_table_cell();
-            $usercell->add_classes(array('user'));
+            $usercell->attributes['class'] = 'user';
             $usercell->header = true;
             $usercell->scope = 'row';
 
@@ -606,7 +606,7 @@ class grade_report_grader extends grade_report {
 
             if (has_capability('gradereport/'.$CFG->grade_profilereport.':view', $this->context)) {
                 $userreportcell = new html_table_cell();
-                $userreportcell->add_class('userreport');
+                $userreportcell->attributes['class'] = 'userreport';
                 $userreportcell->header = true;
                 $a->user = fullname($user);
                 $strgradesforuser = get_string('gradesforuser', 'grades', $a);
@@ -617,7 +617,7 @@ class grade_report_grader extends grade_report {
 
             if ($showuseridnumber) {
                 $idnumbercell = new html_table_cell();
-                $idnumbercell->add_classes(array('header', 'useridnumber'));
+                $idnumbercell->attributes['class'] = 'header useridnumber';
                 $idnumbercell->header = true;
                 $idnumbercell->scope = 'row';
                 $userrow->cells[] = $idnumbercell;
@@ -666,7 +666,7 @@ class grade_report_grader extends grade_report {
             }
 
             $headingrow = new html_table_row();
-            $headingrow->add_class('heading_name_row');
+            $headingrow->attributes['class'] = 'heading_name_row';
 
             foreach ($row as $columnkey => $element) {
                 $sortlink = clone($this->baseurl);
@@ -696,7 +696,7 @@ class grade_report_grader extends grade_report {
 // Element is a filler
                 if ($type == 'filler' or $type == 'fillerfirst' or $type == 'fillerlast') {
                     $fillercell = new html_table_cell();
-                    $fillercell->add_classes(array($type, $catlevel));
+                    $fillercell->attributes['class'] = $type . ' ' . $catlevel;
                     $fillercell->colspan = $colspan;
                     $fillercell->text = '&nbsp;';
                     $fillercell->header = true;
@@ -706,7 +706,7 @@ class grade_report_grader extends grade_report {
 // Element is a category
                 else if ($type == 'category') {
                     $categorycell = new html_table_cell();
-                    $categorycell->add_classes(array('category', $catlevel));
+                    $categorycell->attributes['class'] = 'category ' . $catlevel;
                     $categorycell->colspan = $colspan;
                     $categorycell->text = shorten_text($element['object']->get_name());
                     $categorycell->text .= $this->get_collapsing_icon($element);
@@ -738,10 +738,10 @@ class grade_report_grader extends grade_report {
                     $headerlink = $this->gtree->get_element_header($element, true, $this->get_pref('showactivityicons'), false);
 
                     $itemcell = new html_table_cell();
-                    $itemcell->add_classes(array($type, $catlevel, 'highlightable'));
+                    $itemcell->attributes['class'] = $type . ' ' . $catlevel . 'highlightable';
 
                     if ($element['object']->is_hidden()) {
-                        $itemcell->add_class('hidden');
+                        $itemcell->attributes['class'] .= ' hidden';
                     }
 
                     $itemcell->colspan = $colspan;
@@ -751,7 +751,6 @@ class grade_report_grader extends grade_report {
 
                     $headingrow->cells[] = $itemcell;
                 }
-                
             }
             $rows[] = $headingrow;
         }
@@ -798,7 +797,7 @@ class grade_report_grader extends grade_report {
 
             $itemrow = new html_table_row();
             $itemrow->id = 'user_'.$userid;
-            $itemrow->add_class($rowclasses[$this->rowcount % 2]);
+            $itemrow->attributes['class'] = $rowclasses[$this->rowcount % 2];
 
             $jsarguments['users'][$userid] = fullname($user);
 
@@ -838,19 +837,19 @@ class grade_report_grader extends grade_report {
                 $eid = $this->gtree->get_grade_eid($grade);
                 $element = array('eid'=>$eid, 'object'=>$grade, 'type'=>'grade');
 
-                $itemcell->add_class('grade');
+                $itemcell->attributes['class'] .= ' grade';
                 if ($item->is_category_item()) {
-                    $itemcell->add_class('cat');
+                    $itemcell->attributes['class'] .= ' cat';
                 }
                 if ($item->is_course_item()) {
-                    $itemcell->add_class('course');
+                    $itemcell->attributes['class'] .= ' course';
                 }
                 if ($grade->is_overridden()) {
-                    $itemcell->add_class('overridden');
+                    $itemcell->attributes['class'] .= ' overridden';
                 }
 
                 if ($grade->is_excluded()) {
-                    // $itemcell->add_class('excluded');
+                    // $itemcell->attributes['class'] .= ' excluded';
                 }
 
                 if (!empty($grade->feedback)) {
@@ -950,9 +949,9 @@ class grade_report_grader extends grade_report {
                     $gradedisplaytype = $item->get_displaytype();
 
                     if ($item->scaleid && !empty($scalesarray[$item->scaleid])) {
-                        $itemcell->add_class('grade_type_scale');
+                        $itemcell->attributes['class'] .= ' grade_type_scale';
                     } else if ($item->gradetype != GRADE_TYPE_TEXT) {
-                        $itemcell->add_class('grade_type_text');
+                        $itemcell->attributes['class'] .= ' grade_type_text';
                     }
 
                     if ($item->needsupdate) {
@@ -1020,20 +1019,17 @@ class grade_report_grader extends grade_report {
         if ($fixedstudents) {
             $fixedcolumntable = new html_table();
             $fixedcolumntable->id = 'fixed_column';
-            $fixedcolumntable->add_class('fixed_grades_column');
-            $fixedcolumntable->bodyclasses = 'leftbody';
             $fixedcolumntable->data = $leftrows;
-            $html .= $OUTPUT->container($OUTPUT->table($fixedcolumntable), 'left_scroller');
+            $html .= $OUTPUT->container(html_writer::table($fixedcolumntable), 'left_scroller');
 
             $righttable = new html_table();
             $righttable->id = 'user-grades';
-            $righttable->bodyclasses = array('righttest');
             $righttable->data = $rightrows;
 
-            $html .= $OUTPUT->container($OUTPUT->table($righttable), 'right_scroller');
+            $html .= $OUTPUT->container(html_writer::table($righttable), 'right_scroller');
         } else {
             $fulltable = new html_table();
-            $fulltable->add_classes(array('gradestable', 'flexible', 'boxaligncenter', 'generaltable'));
+            $fulltable->attributes['class'] = 'gradestable flexible boxaligncenter generaltable';
             $fulltable->id = 'user-grades';
 
             // Extract rows from each side (left and right) and collate them into one row each
@@ -1041,7 +1037,7 @@ class grade_report_grader extends grade_report {
                 $row->cells = array_merge($row->cells, $rightrows[$key]->cells);
                 $fulltable->data[] = $row;
             }
-            $html .= $OUTPUT->table($fulltable);
+            $html .= html_writer::table($fulltable);
         }
         return $OUTPUT->container($html, 'gradeparent');
     }
@@ -1058,9 +1054,9 @@ class grade_report_grader extends grade_report {
 
         if ($USER->gradeediting[$this->courseid]) {
             $controlsrow = new html_table_row();
-            $controlsrow->add_class('controls');
+            $controlsrow->attributes['class'] = 'controls';
             $controlscell = new html_table_cell();
-            $controlscell->add_classes(array('header', 'controls'));
+            $controlscell->attributes['class'] = 'header controls';
             $controlscell->colspan = $colspan;
             $controlscell->text = $this->get_lang_string('controls','grades');
 
@@ -1081,9 +1077,9 @@ class grade_report_grader extends grade_report {
 
         if ($this->get_pref('showranges')) {
             $rangerow = new html_table_row();
-            $rangerow->add_classes(array('range', 'r'.$this->rowcount++));
+            $rangerow->attributes['class'] = 'range r'.$this->rowcount++;
             $rangecell = new html_table_cell();
-            $rangecell->add_classes(array('header', 'range'));
+            $rangecell->attributes['class'] = 'header range';
             $rangecell->colspan = $colspan;
             $rangecell->header = true;
             $rangecell->scope = 'row';
@@ -1116,9 +1112,9 @@ class grade_report_grader extends grade_report {
         if ($groupavg) {
             if ($showaveragesgroup) {
                 $groupavgrow = new html_table_row();
-                $groupavgrow->add_classes(array('groupavg', 'r'.$this->rowcount++));
+                $groupavgrow->attributes['class'] = 'groupavg r'.$this->rowcount++;
                 $groupavgcell = new html_table_cell();
-                $groupavgcell->add_classes(array('header', 'range'));
+                $groupavgcell->attributes['class'] = 'header range';
                 $groupavgcell->colspan = $colspan;
                 $groupavgcell->header = true;
                 $groupavgcell->scope = 'row';
@@ -1131,9 +1127,9 @@ class grade_report_grader extends grade_report {
 
             if ($showaverages) {
                 $avgrow = new html_table_row();
-                $avgrow->add_classes(array('avg', 'r'.$this->rowcount++));
+                $avgrow->attributes['class'] = 'avg r'.$this->rowcount++;
                 $avgcell = new html_table_cell();
-                $avgcell->add_classes(array('header', 'range'));
+                $avgcell->attributes['class'] = 'header range';
                 $avgcell->colspan = $colspan;
                 $avgcell->header = true;
                 $avgcell->scope = 'row';
@@ -1155,7 +1151,7 @@ class grade_report_grader extends grade_report {
         global $USER;
         if ($USER->gradeediting[$this->courseid]) {
             $iconsrow = new html_table_row();
-            $iconsrow->add_class('controls');
+            $iconsrow->attributes['class'] = 'controls';
 
             $showuseridnumber = $this->get_pref('showuseridnumber');
 
@@ -1166,7 +1162,7 @@ class grade_report_grader extends grade_report {
                 $eid = $this->gtree->get_item_eid($item);
                 $element = $this->gtree->locate_element($eid);
                 $itemcell = new html_table_cell();
-                $itemcell->add_classes(array('controls', 'icons'));
+                $itemcell->attributes['class'] = 'controls icons';
                 $itemcell->text = $this->get_icons($element);
                 $iconsrow->cells[] = $itemcell;
             }
@@ -1187,13 +1183,13 @@ class grade_report_grader extends grade_report {
             $rangesdisplaytype   = $this->get_pref('rangesdisplaytype');
             $rangesdecimalpoints = $this->get_pref('rangesdecimalpoints');
             $rangerow = new html_table_row();
-            $rangerow->add_classes(array('heading', 'range'));
+            $rangerow->attributes['class'] = 'heading range';
 
             foreach ($this->gtree->items as $itemid=>$unused) {
                 $item =& $this->gtree->items[$itemid];
                 $itemcell = new html_table_cell();
                 $itemcell->header = true;
-                $itemcell->add_classes(array('header', 'range'));
+                $itemcell->attributes['class'] .= ' header range';
 
                 $hidden = '';
                 if ($item->is_hidden()) {
@@ -1301,7 +1297,7 @@ class grade_report_grader extends grade_report {
             $ungradedcounts = $DB->get_records_sql($SQL, $params);
 
             $avgrow = new html_table_row();
-            $avgrow->add_class('avg');
+            $avgrow->attributes['class'] = 'avg';
 
             foreach ($this->gtree->items as $itemid=>$unused) {
                 $item =& $this->gtree->items[$itemid];
diff --git a/group/autogroup.php b/group/autogroup.php
index 3e2e66b..34057dc 100644
--- a/group/autogroup.php
+++ b/group/autogroup.php
@@ -171,7 +171,7 @@ if ($editform->is_cancelled()) {
             $table->data[] = $line;
         }
 
-        $preview .= $OUTPUT->table($table);
+        $preview .= html_writer::table($table);
 
     } else {
         $grouping = null;
diff --git a/group/groupings.php b/group/groupings.php
index 5eeea45..4208955 100644
--- a/group/groupings.php
+++ b/group/groupings.php
@@ -98,7 +98,7 @@ $table->size  = array('30%', '50%', '10%', '10%');
 $table->align = array('left', 'left', 'center', 'center');
 $table->width = '90%';
 $table->data  = $data;
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->container_start('buttons');
 echo $OUTPUT->single_button(new moodle_url('grouping.php', array('courseid'=>$courseid)), $srtnewgrouping);
diff --git a/group/overview.php b/group/overview.php
index ad8e5c5..a9e8d2d 100644
--- a/group/overview.php
+++ b/group/overview.php
@@ -207,7 +207,7 @@ foreach ($members as $gpgid=>$groupdata) {
             echo $OUTPUT->box(format_text($description, $groupings[$gpgid]->descriptionformat, $options), 'generalbox boxwidthnarrow boxaligncenter');
         }
     }
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
     $printed = true;
 }
 
